#!/bin/sh
#
#

source ./functions.sh
version_path=/var/www/innovaphone

rm -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart
version=`tr -d '\n\r ' < ${version_path}/version`
for folder in $(ls -1 | grep -o '^[0-9]*$')
do
    if [ ${version} -gt ${folder} ]; then
        log_msg "Ignoring already installed service release for build ${folder}"
    elif [ ${version} -eq ${folder} ]; then
        log_msg "Installing service release for build ${folder}"
        cd ${folder}
        gzip -d *.gz
        tar_file=`ls -1 *.tar`
        tar xf ${tar_file}
        rm ${tar_file}
        cp ../php_template.sh .
        dos2unix *.sh
        install_exes=( $(ls install*.*) )
        num_exes=${#install_exes[@]}
        if [ ${num_exes} -eq 1 ]; then
            install_exe=${install_exes[0]}
            chmod 755 ${install_exe}
            log_msg "Executing installation script ${install_exe}"
            ./${install_exe} 1
            if [ $? -ne 0 ]; then
                throw_error "Service release installation failed"
            fi
        else
            throw_error "No installation script found"
        fi
        cd ..
        version=`tr -d '\n\r ' < ${version_path}/version`
    elif [ ${version} -lt ${folder} ]; then
        throw_error "Currently installed build is ${version}. Can't apply service release for build ${folder}."
    fi
done

if [ -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart ]; then
    log_msg "The web server will be restarted a few seconds after the installation!"
fi
log_msg "Installation was successful"
if [ -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart ]; then
    sleep 10s
    php5-cgi /var/www/innovaphone/update_webserver_cfg.php
    rm -f /var/www/innovaphone/tmp/hotfix_lighttpd.restart
fi