# build binary pam-change-pw
#
# this makefile requires the builder make from vault $product\builder\tools\MAKETLS
# and cygwin
#

#
# we use sh.exe of cygwin as shell 
#
SHELL=sh

#
# as cygwin breaks file permissions when run outside its own shell, we'll fix these by using functions which execute icacls afterwards
#
mkdir_make = mkdir -p $(1);icacls $(1) /reset /T

SYSROOT_VERSION=linux-12r1/sysroot/120001

GCC_FLAGS=-v -Wl,-verbose

ifeq ($(MAKECMDGOALS),armel)
	SYSROOT:=$(T)/$(SYSROOT_VERSION)/armel
    GCC_FLAGS:=$(GCC_FLAGS) -Wl,-rpath,$(SYSROOT)/lib/arm-linux-gnueabi -Wl,-rpath,$(SYSROOT)/usr/lib/arm-linux-gnueabi
    BUILD=build_armel
    CC=arm-linux-gnueabi-gcc.exe
endif

ifeq ($(MAKECMDGOALS),i386)
	SYSROOT:=$(T)/$(SYSROOT_VERSION)/i386
    GCC_FLAGS:=$(GCC_FLAGS) -Wl,-rpath,$(SYSROOT)/lib/i386-linux-gnu -Wl,-rpath,$(SYSROOT)/usr/lib/i386-linux-gnu
    BUILD=build_i386
    CC=i486-linux-gnu-gcc.exe
endif

GCC_FLAGS:=$(GCC_FLAGS) --sysroot=$(SYSROOT) 

OUT=pam-change-pw

# list all c files here
C_FILES=pam-change-pw.c

# list all additional libraries here
LIBS=-lpam

.PHONY: armel i386

armel:
	rm -f -r $(BUILD)
	$(call mkdir_make,$(BUILD))
	$(CC) $(GCC_FLAGS) -o $(BUILD)/$(OUT) $(C_FILES) $(LIBS)

i386:
	rm -f -r $(BUILD)
	$(call mkdir_make,$(BUILD))
	$(CC) $(GCC_FLAGS) -o $(BUILD)/$(OUT) $(C_FILES) $(LIBS)

cleanup:
	rm -f -r build_armel
	rm -f -r build_i386

