<?
require_once("include_main.php");

$type = isset($_GET["type"]) ? $_GET["type"] : null;
$file = isset($_GET["file"]) ? $_GET["file"] : null;
$format = isset($_GET["format"]) ? $_GET["format"] : "";

switch($type) {
    case "show":
        show_certificate($file);
        break;
    case "show_req":
        show_request($file);
        break;
    case "download":
        download_certificate($file, $format);
        break;
    case "download_req":
        download_csr_request($file);
        break;
}

function show_certificate($file) {
    date_default_timezone_set("UTC");
    $cmd = "/usr/bin/sudo /usr/local/bin/config.sh ssl read ".$file;
    $cert = main_system($cmd, $retval);
    if($retval != 0) {
        $xml = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<error>Certificate could not be read</error>";
    } else {
        $c = Certificates::getCertificate($cert);
        $certContent = str_replace("-----BEGIN CERTIFICATE-----", "", $cert);
        $certContent = str_replace("-----END CERTIFICATE-----", "", $certContent);
        $certContent = str_replace("\n", "", $certContent);
        $certDecode = base64_decode($certContent);
        header('Pragma: private');
        header('Cache-control: private, must-revalidate');
        header('Content-type: text/xml');
        $xml = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n".
            "<?xml-stylesheet type=\"text/xsl\" href=\"certificate.xsl\"?>\n";
        $xml .= "<info>";
        $xml .= "    <certificate ";
        $xml .=      " subject=\"".xmlentities(get_desc($c->subject))."\"";
        $xml .=      " subject_cn=\"".xmlentities($c->subject["CN"])."\"";
        $xml .=      " issuer=\"".xmlentities(get_desc($c->issuer))."\"";
        $xml .=      " serial_number=\"".lrgDec2Hex($c->serial)."\"";
        $xml .=      " version=\"X.509 v".$c->version."\""; 
        $xml .=      " key_type=\"RSA\"";
        $xml .=      " key_strength=\"".$c->bits."\"";
        $xml .=      " fingerprint_sha1=\"".strtoupper(wordwrap(sha1($certDecode), 2, ":", true))."\"";
        $xml .=      " fingerprint_md5=\"".strtoupper(wordwrap(md5($certDecode), 2, ":", true))."\"";
        $xml .=      " not_before=\"".date(MainInputPage::dateFormat, $c->notBefore)."\"";
        $xml .=      " not_after=\"".date(MainInputPage::dateFormat, $c->notAfter)."\"";
        $xml .=      " ca=\"".($c->ca ? "true" : "false")."\"";
        //$xml .=      " path_length=\"0\"";
        $xml .=      " key_usage=\"".xmlentities($c->purposes)."\"";
        $xml .=      " subject_key_id=\"".$c->subjectKeyId."\"";
        $xml .=      " authority_key_id=\"".$c->authKeyId."\"/>";
        $xml .= "</info>";
    }
    echo $xml;
}

function lrgDec2Hex($number)
{
    $len = strlen($number);
    $i = 0;
    $hex = array();

    while($i < $len) {
        if($number == 0) {
            array_push($hex, '0');
        }
        else {
            array_push($hex, strtoupper(dechex(bcmod($number, '16'))));
            $number = bcdiv($number, '16', 0);
        }
        $i++;
    }
    krsort($hex);
    return ltrim(implode($hex), "0");
} 

function get_desc($desc) {
    $ret = "";
    foreach($desc as $name => $value) {
        $ret .= "$name=";
        if(is_array($value)) {
            $ret .= $value[0];
        }
        else {
            $ret .= $value;
        }
        $ret .= " ";
    }
    rtrim($ret, " ");
    return $ret;
}

function download_certificate($file, $format) {
    if(!strcmp($format, "der")) {
        $file = str_replace(".crt", ".der", $file);
    }
    $cmd = "/usr/bin/sudo /usr/local/bin/config.sh ssl read ".$file;
    $content = main_system($cmd, $retval);
    if($retval != 0) {
        // ERROR!!!
    } else {
        // cut private stuff
        $rsaStart = "-----BEGIN RSA PRIVATE KEY-----";
        if(($start = strpos($content, $rsaStart)) !== false) {
            $rsaEnd = "-----END RSA PRIVATE KEY-----";
            $end = strpos($content, $rsaEnd, $start);
            $newContent = substr($content, 0, $start);
            $newContent .= substr($content, $end + strlen($rsaEnd));
            $content = trim($newContent, "\r\n");
            $content = trim($content, "\n");
        }
        else {
            $rsaStart = "-----BEGIN PRIVATE KEY-----";
            if(($start = strpos($content, $rsaStart)) !== false) {
                $rsaEnd = "-----END PRIVATE KEY-----";
                $end = strpos($content, $rsaEnd, $start);
                $newContent = substr($content, 0, $start);
                $newContent .= substr($content, $end + strlen($rsaEnd));
                $content = trim($newContent, "\r\n");
                $content = trim($content, "\n");
            }
        }
        $fileName = trim(strrchr($file, "/"), "/");
        if(!strcmp($format, "der")) {
            $fileName = str_replace(".pem", ".der", $fileName);
        }
        header('Pragma: private');
        header('Cache-control: private, must-revalidate');
        header("Content-Disposition: attachment; filename=\"$fileName\"");
        header('Content-type: application/octet-stream');
        header('Content-len: '.strlen($content));
        echo $content;
    }
}

function show_request($file) {
    date_default_timezone_set("UTC");
    $cfile = "/home/root/ssl_cert/requests/".$file;
    $cmd = "/usr/bin/sudo /usr/local/bin/config.sh ssl read ".$cfile;
    $cert = main_system($cmd, $retval);
    if($retval != 0) {
        $xml = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n<error>Certificate could not be read</error>";
    } else {
        $sigType = "SHA1";
        $signature = "";
        $cmd = "openssl req -text -noout -in ".$cfile." | grep 'sha256WithRSAEncryption'";
        exec($cmd, $signature);
        if($signature) {
            $sigType = "SHA256";
        }
        else {
            $signature = "";
            $cmd = "openssl req -text -noout -in ".$cfile." | grep 'sha384WithRSAEncryption'";
            exec($cmd, $signature);
            if($signature) {
                $sigType = "SHA384";
            }
            else {
                $signature = "";
                $cmd = "openssl req -text -noout -in ".$cfile." | grep 'sha512WithRSAEncryption'";
                exec($cmd, $signature);
                if($signature) {
                    $sigType = "SHA512";
                }
            }
        }
        $content = "";
        $cmd = "openssl req -text -noout -in ".$cfile." | grep 'Digital Signature'";
        exec($cmd, $content);
        if(!$content) {
            $keyUsage = "";
        }
        else {
            $keyUsage = $content[0];
        }
        $content = "";
        $cmd = "openssl req -text -noout -in ".$cfile." | grep 'Server Authentication'";
        exec($cmd, $content);
        if($content) {
            if($keyUsage !== "")
                $keyUsage .= ", ".$content[0];
            else
                $keyUsage = $content[0];
        }
        $content = "";
        $cmd = "openssl req -text -noout -in ".$cfile." | grep 'Public-Key' | egrep -oe '[0-9]*'";
        exec($cmd, $content);
        if(!$content) {
            $strength = 1024;
        }
        else {
            $strength = $content[0];
        }
        $content = "";
        $cmd = "openssl req -text -noout -in ".$cfile." | grep 'Subject: ' | tr -d ' ' | sed 's/,/ /g' | cut -c 9-";
        exec($cmd, $content);
        if(!$content) {
            $subject = "";
        }
        else {
            $subject = $content[0];
        }
        $dnsIp = array();
        $content = "";
        $cmd = "openssl req -text -noout -in ".$cfile." | grep 'DNS:\|IP A' | tr -d ' '";
        exec($cmd, $content);
        if(!$content) {
            $dnsIps = "";
        }
        else {
            $dnsInd = 1;
            $ipInd = 1;
            $dnsIps = explode(",", $content[0]);
            foreach($dnsIps as $val) {
                $temp = explode(":", $val);
                if(!strcmp($temp[0],"DNS")) {
                    $dnsIp["dns".$dnsInd] = $temp[1];
                    $dnsInd++;
                }
                elseif(!strcmp($temp[0],"IPAddress")) {
                    $dnsIp["ip".$ipInd] = $temp[1];
                    $ipInd++;
                }
            }
        }
        $certContent = str_replace("-----BEGIN CERTIFICATE REQUEST-----", "", $cert);
        $certContent = str_replace("-----END CERTIFICATE REQUEST-----", "", $certContent);
        $certContent = str_replace("\n", "", $certContent);
        $certDecode = base64_decode($certContent);
        header('Pragma: private');
        header('Cache-control: private, must-revalidate');
        header('Content-type: text/xml');
        $xml = "<?xml version=\"1.0\" encoding=\"utf-8\"?>\n".
            "<?xml-stylesheet type=\"text/xsl\" href=\"certificate.xsl\"?>\n";
        $xml .= "<info>";
        $xml .= "    <certificate ";
        if($subject != "")
            $xml .=      " subject=\"".xmlentities($subject)."\"";
        $dnsInd = 1;
        $ipInd = 1;
        if(count($dnsIp)) {
            foreach($dnsIp as $ind => $val) {  
                $xml .=      " ".$ind."=\"".$val."\"";
            }
        }
        $xml .=      " ca=\"false\"";
        $xml .=      " key_usage=\"".$keyUsage."\"";
        $xml .=      " key_type=\"RSA\"";
        $xml .=      " key_strength=\"".$strength."\"";
        $xml .=      " fg_sha=\"".$sigType."\"";
        $xml .=      "/>";
        $xml .= "</info>";
    }
    echo $xml;
}

function download_csr_request($file) {
    $cmd = "/usr/bin/sudo /usr/local/bin/config.sh ssl read ".$file;
    $content = main_system($cmd, $retval);
    if($retval != 0) {
        // ERROR!!!
    } else {
        $fileName = trim(strrchr($file, "/"), "/");
        header('Pragma: private');
        header('Cache-control: private, must-revalidate');
        header("Content-Disposition: attachment; filename=\"$fileName\"");
        header('Content-type: application/octet-stream');
        header('Content-len: '.strlen($content));
        echo $content;
    }
}


?>
