<?php

class Alarms {
    const offset                                = 0x00180000;   // Linux-Alarms
    const phpOffset                             = 0x96;         // 0x00 - 0x95 are reserved for process.fcgi
    const alCertError                           = 0x00;
    const alCertRejected                        = 0x01;
    const alRetrieveBackupScript                = 0x02;
    const alBackupFailed                        = 0x03;
    const alDiskFull                            = 0x04;
    const alExchangeConnectDb                   = 0x100;
    const alExchangeDeleteUsers                 = 0x101;
    const alExchangeSoapInit                    = 0x102;
    const alExchangeSoapFindUser                = 0x103;
    const alExchangeEwsInit                     = 0x104;
    const alExchangeResolveNames                = 0x105;
    const alExchangeInsertUser                  = 0x106;
    const alExchangeUpdateUser                  = 0x107;
    const alExchangeUpdateUserSubscription      = 0x108;
    const alExchangeSubscribe                   = 0x109;
    const alExchangeUpdateUserGuid              = 0x10a;
    const alExchangeDeleteCalendarItems         = 0x10b;
    const alExchangeInsertCalendarItem          = 0x10c;
    const alExchangeUpdateUserAvailability      = 0x10d;
    const alExchangeUpdateUserSubscription2     = 0x10e;
    const alExchangeGetCalendarItems            = 0x10f;
    const alExchangePresenceUpdate              = 0x110;
    const alExchangeUpdatePbxStatus             = 0x111;
    const alExchangeGetAvailability             = 0x112;
    const alExchangeConvertCalendarId           = 0x113;
    const alExchangeGetItemCalendar             = 0x114;
    const alExchangeLastRun                     = 0x115;
    const alExchangeSoapVersion                 = 0x116;
    const alExchangeSoapWrongVersion            = 0x117;
    const alFaxOffset                           = 0x200;        // offset for Fax alarms 0x200 - 0x2ff
    
    static function getFullCode($code) {
        return sprintf("0x%08x", self::offset + $code + self::phpOffset);
    }
    
    static function alarmFile($code) {
        return Config::alarmFilePrefix.self::getFullCode($code);
    }
}

class Config {
    const majorVersion = "/var/www/innovaphone/majorversion";
    const kernelVersion = "/var/www/innovaphone/kernel";
    const lighttpdRealm = "Linux Web Server";
    const webRoot = "/var/www/innovaphone";
    const installRunning = "/var/www/innovaphone/install_running";
    const installFile = "webdav/install/install.tar.gz";
    const installFileDir = "webdav/install/";
    const announceDir = "/var/www/innovaphone/webdav/announcements";
    const imagesDir = "/var/www/innovaphone/apps/innovaphone-reporting/report_images";
    const applicationsDir = "apps";
    const tmpBackupSerials = "tmp/backup_serials/";
    const mainInstallLog = "/var/log/init_install.log";
    const aptHistoryLog = "/var/log/apt/history.log";
    const applInstallLog = "/var/www/innovaphone/log/appl_install.log";
    const applUninstallLog = "/var/www/innovaphone/log/appl_uninstall.log";
    const pgHba = "/etc/postgresql/9.1/main/pg_hba.conf";
    const pgConf = "/etc/postgresql/9.1/main/postgresql.conf";
    const pgUser = "postgres"; // default password is postgres, md5=e8a48653851e28c69d0506508fb27fc5
    const serverPassFile = "/home/lighttpd/lighttpd_htdigest.user";
    const webdavPassFile = "/home/lighttpd/webdav_htdigest.user";
    const serverCfgFile = "/home/lighttpd/server_config/innovaphone.conf";
    const lighttpdCfgFile = "/etc/lighttpd/lighttpd.conf";
    const backupLog = "/var/www/innovaphone/log/backup.log";
    const installedPackages = "/home/lighttpd/server_config/packages.log";    
    const rootfsPackages = "/home/innovaphone/rootfs_packages";    
    const lighttpdConfLog = "/var/www/innovaphone/log/innovaphone.log";
    const pgAnalyzeLog = "/var/www/innovaphone/log/pg_analyze.log";
    const backupScript = "/var/www/innovaphone/backup.php";
    const debInstalledPackages = "/var/log/installed_debian_packages.log";
    const innovaphoneDbDump = "innovaphone_db.dump";
    const reportingDbDump = "reporting_db.dump";
    const exchangeDbDump = "exchange_db.dump";
    const faxserverDbDump = "faxserver_db.dump";
    const certDirTrusted = "/home/lighttpd/server_config/certs/trusted";
    const certDirRejected = "/home/lighttpd/server_config/certs/rejected";
    const certRequests = "/home/root/ssl_cert/requests";
    const certSelfSignedCerts = "/home/root/ssl_cert/ss_certs";
    const certServer = "/home/root/ssl_cert/server.pem";
    const certDiffieHellman = "/home/root/ssl_cert/dhparams.pem";
    const certServerKey = "/home/root/ssl_cert/server.key";
    const certServerCert = "/home/root/ssl_cert/server.crt";
    const certDirServer = "/home/root/ssl_cert";
    const certMD5sum = "201b5ee879484add1f215029e219bc39";
    const quitFile = "/home/lighttpd/quit.in";
    const reportingCleanupLog = "/var/www/innovaphone/apps/innovaphone-reporting/log/reporting_cleanup.log";
    const reportingCDRCleanupLog = "/var/www/innovaphone/apps/innovaphone-reporting/log/reporting_cdr_cleanup.log";
    const reportingLogDir = "/var/www/innovaphone/apps/innovaphone-reporting/log/";
    const reportingLog = "/var/www/innovaphone/apps/innovaphone-reporting/log/innovaphone-reporting.log";
    const reportingReplicationLog = "/var/www/innovaphone/apps/innovaphone-reporting/log/reporting_replication.log";
    const reportingConfig = "/home/innovaphone-reporting/reporting.conf";
    const reportingFilterConfig = "/home/innovaphone-reporting/reporting_filter.conf";
    const reportingReplicationBin = "/usr/local/bin/reporting_replication.out";
    const reportingReplicationSh = "/usr/local/bin/reporting_replication.sh";
    const reportingReplicationBinLock = "/home/innovaphone-reporting/tmp/reporting_replication.running";
    const reportingReplicationStatus = "/home/innovaphone-reporting/tmp/replication_status.log";
    const exchangeLogDir = "/var/www/innovaphone/apps/innovaphone-exchange/log/";
    const exchangeLog = "/var/www/innovaphone/apps/innovaphone-exchange/log/innovaphone-exchange.log";
    const exchangeConfig = "/home/innovaphone-exchange/exchange.conf";
    const faxLogDir = "/var/www/innovaphone/apps/innovaphone-faxserver/log/";
    const faxLog = "/var/www/innovaphone/apps/innovaphone-faxserver/log/*.*";
    const faxConfig = "/home/innovaphone-faxserver/faxserver.conf";
    const lighttpdLog = "/var/log/lighttpd/error.log";
    const postgreSqlLog = "/var/log/postgresql/postgresql-9.1-main.log";
    const mailLog = "/var/log/mail.log";
    const mailAllLog = "/var/log/mail.";
    const kernelLog = "/var/log/kern.log";
    const syslogLog = "/var/log/syslog";
    const cronInnovaphoneBackup = "/etc/cron.d/innovaphone_backup";
    const cronReportingCleanup = "/etc/cron.d/reporting_cleanup";
    const cronReportingReplication = "/etc/cron.d/reporting_replication";
    const cronReportingMails = "/etc/cron.d/reporting_mails";
    const cronReportingCDRCleanup = "/etc/cron.d/reporting_cdr_cleanup";
    const cronExchange = "/etc/cron.d/innovaphone_exchange";
    const ntpConf = "/etc/ntp.conf";
    const confTempFile = "/home/lighttpd/server_config/lighttpd.conf";
    const confTemplate = "/home/lighttpd/server_config/main_template";
    const confPasswdWeb = "/home/lighttpd/server_config/passwd_template_web";
    const confPasswdWebDav = "/home/lighttpd/server_config/passwd_template_webdav";
    const wikiHelp = "http://wiki.innovaphone.com/index.php?title=Reference10:Concept_Linux_Application_Platform";
    const wikiHelpReporting = "http://wiki.innovaphone.com/index.php?title=Reference10:Concept_Reporting";
    const wikiHelpExchange = "http://wiki.innovaphone.com/index.php?title=Reference10:Concept_Exchange_Calendar_Connector";
    const wikiHelpFaxserver = "http://wiki.innovaphone.com/index.php?title=Reference10:Concept_Faxserver";
    const traceLevelFile = "/var/www/innovaphone/trace.level";
    const missingPackages = "/var/www/innovaphone/log/missing_packages.log";
    const alarmFilePrefix = "/var/www/innovaphone/tmp/alarm";
    const configCheckSsl = "/tmp/config.sh.ap.ssl";                    
    const configCheckCron = "/tmp/config.sh.ap.cron";                  
    const configCheckReload = "/tmp/config.sh.ap.reload";              
    const configCheckTimezone = "/tmp/config.sh.ap.timezone";          
    const configCheckNtp = "/tmp/config.sh.ap.ntp";                    
    const configCheckRpcap = "/tmp/config.sh.ap.rpcap";                
    const configCheckPostgres = "/tmp/config.sh.ap.postgres";          
    const configCheckApplication = "/tmp/config.sh.ap.application";    
    const configCheckInnovaphone = "/tmp/config.sh.ap.innovaphone";    
    const configCheckReporting = "/tmp/config.sh.reporting.postgres";
    const configErrorSsl = 10;
    const configErrorCron = 11;
    const configErrorReload = 12;
    const configErrorTimezone = 13;
    const configErrorNtp = 15;
    const configErrorRpcap = 18;
    const configErrorPostgres = 19;
    const configErrorApplication = 30;
    const configErrorInnovaphone = 40;
    // exit 1, no arguments passed to config.sh
    // exit 14, timezone: timezone does not exist
    // exit 16, ntp: ntpd process not running
    // exit 17, ntp: Can't create temp file
    // exit 20, postgres: Can't create temp file
    // exit 21, postgres: database, username or ip is missing (delete-ip)
    // exit 22, postgres: database, username or ip is missing (add-ip)
    // exit 23, postgres: check password error
    // exit 24, postgres: alter password error
    // exit 25, postgres: no new password provided
    // exit 26, postgres: please enter a valid database name
    // exit 27, postgres: update file does not exist
    // exit 28, postgres: Can't create temp file (db-restore)
    // exit 29, postgres: Can't delete existing database (db-restore)
    // exit 41, innovaphone: missing arguments
    // exit 50, mail-smtp: missing arguments
    // exit 51, mails: no destination address available
    // exit 60, rsyslog: rsyslog couldn't be reloaded
    // exit 70, log-files: no arguments provided
    // exit 71, log-files: Can't create temp file
    // exit 72, log-files: curl error
    // exit 73, log-files: unknown HTTP method
    // exit 99, trap function. Program stopped unexpectedly?
    const ldapServersChanged = "/home/innovaphone-reporting/tmp/ldap_changed";
    const networkFile = "/etc/network/interfaces";
    const dnsFile = "/etc/resolv.conf";
    const dhcpFile = "/var/lib/dhcp/dhclient.eth0.leases";
    
    const mtlsPath = "/var/www/innovaphone/mtls";
    const mtlsPort = "444";
    const mtlsCert = "/home/root/ssl_cert/innovaphone-ca.pem";
}

?>
